type NormalizeStringOptions = {
    /**
     * Remove accents from the string
     * @default true
     */
    removeAccents?: boolean;
    /**
     * Keep the case of the string
     * @default false
     */
    caseSensitive?: boolean;
    /**
     * Replace spaces with `-`
     * @default true
     */
    replaceSpaces?: boolean;
    /**
     * Remove special characters
     * Be careful, only for languages that use the Latin alphabet
     * @default false
     */
    removeSpecialCharacters?: boolean;
    /**
     * Remove leading and trailing whitespaces
     * @default true
     */
    trim?: boolean;
    /**
     * Normalize spaces
     * Will replace multiple spaces with a single space
     * @default true
     */
    normalizeSpaces?: boolean;
    /**
     * Remove numbers
     * @default false
     */
    removeNumbers?: boolean;
    /**
     * Normalize the string with custom normalization forms
     * @default ['NFC', 'NFKD']
     * @see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/normalize
     * options: 'NFC', 'NFD', 'NFKC', 'NFKD'
     */
    customNormalizationForms?: string[];
};
export declare function normalizeString(input: string | number | boolean, options?: NormalizeStringOptions): string;
export {};
